#include<stdlib.h>
#include<fstream>
#include<iostream>
#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/graph.h>
#include <LEDA/graph/edge_array.h>
#include <LEDA/graph/node_array.h>
#include<LEDA/graph/graph_alg.h>

using namespace leda;
using namespace std;

#define SIZE 500
#define N 56

double loop(graph& G,int n,double dis[SIZE][SIZE]);
double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d);

int main()
{
  int i,j;
  double dis[SIZE][SIZE];
  char B[N][N];
  double G_cost;

  ifstream fi;
  fi.open("nj/fileout/hori-jis-fileout");


  for(i=0;i<N;i++){
    for(j=0;j<N;j++){
      if(i==j){
	dis[i][j]=0;
	//cout << dis[i][j] <<' ';
      }else{
	fi>>B[0];
	//fi>>B[0];
	fi>>dis[i][j];
	//cout << dis[i][j] <<' ';
      }
    }
    // putchar('\n');
  }

  fi.close();
  

  GRAPH<int,int> G;
  G.read("nj/gw/nj-hori-jis");

 
  G_cost=loop(G,N,dis);


  return 0;
}
double loop(graph& G,int n,double dis[SIZE][SIZE]){
  int a,b,c,d;
  double cost=0;

  for(a=0;a<n-3;a++){
    for(b=a+1;b<n-2;b++){
      for(c=b+1;c<n-1;c++){
	for(d=c+1;d<n;d++){
	  cost=cost+quartet_cost(G,n,dis,a,b,c,d);
	}
      }
    }
  }

  return(cost);
}

double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d){
  int a_to[SIZE]={0};
  int d_to[SIZE]={0};
  int i=0,j=0;
  int x=0,y=0,k;
  char hougen_name[N][N]={0};
  double q_cost;
  edge_array<int> cost(G,1);
  node_array<int> dist_a(G,MAXINT);
  node_array<int> dist_d(G,MAXINT);
  node_array<edge> pred_a(G);
  node_array<edge> pred_d(G);

  ifstream f_in("filename");
  if(!f_in) return 1;
  
  for(k=0;k<n;k++){
    f_in >> hougen_name[k];
  }
  
  f_in.close();

  node v,na,nb,nc,nd;
  forall_nodes(v,G){
    if(index(v)==a){
      na=v;
    }else if(index(v)==b){
      nb=v;
    }else if(index(v)==c){
      nc=v;
    }else if(index(v)==d){
      nd=v;
    }
  }
  DIJKSTRA(G,na,cost,dist_a,pred_a);
  DIJKSTRA(G,nd,cost,dist_d,pred_d);
  
  edge e;
  node u,w;
  
  /**************Check quartet (ab|cd)***************/
  
  forall_nodes(w,G){
    if(w==nb){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nc){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }
  
  for(i=0;i<dist_a[nb];i++){
    for(j=0;j<dist_d[nc];j++){
      if(a_to[i]==d_to[j]){
	x=1;
	break;
      }
    }
    if(x){break;}
  }

  /**************Check quartet (ab|cd)***************/
  i=0;
  j=0;
  /**************Check quartet (ac|bd)***************/

  forall_nodes(w,G){
    if(w==nc){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nb){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }

  for(i=0;i<dist_a[nc];i++){
    for(j=0;j<dist_d[nb];j++){
      if(a_to[i]==d_to[j]){
	y=1;
	break;
      }
    }
    if(y){break;}
  }

  /**************Check quartet (ac|bd)***************/
 
  if(x==1 && y==1){
    cout << hougen_name[a] << " " << hougen_name[d] << " " << "|" << " " << hougen_name[b] << " " << hougen_name[c] << endl;
  }else if(x==0){
    cout << hougen_name[a] << " " << hougen_name[b] << " " << "|" << " " << hougen_name[c] << " " << hougen_name[d] << endl;
  }else if(y==0){
    cout << hougen_name[a] << " " << hougen_name[c] << " " << "|" << " " << hougen_name[b] << " " << hougen_name[d] << endl;
  }else{
    cout << "Error!!" << endl;
  }
 
  /*
  if(x==1 && y==1){
    q_cost=dis[a][d]+dis[b][c];
  }else if(x==0){
    q_cost=dis[a][b]+dis[c][d];
  }else if(y==0){
    q_cost=dis[a][c]+dis[b][d];
  }else{
    cout << "Error!!" << endl;
  }
  */
  return(q_cost);
}
